function rih(w,x,pshoe)

%% Trykket i brnnen Vil stige pga surge/swab + kningen i fluid interface. Begge deler m korrigeres for ved  ke/senke fluid interface.
% Dette for  holde BHP og P,casingshoe konstant!
% => Simulatoren baseres p et sekund lange intervaller
% => For at hvert sekund skal kunne legges inn som resultat, s m trykket
% vre OK. Dersom minimum trippehastighet er ndd, m man likevel trippe,
% og man m heller bare ta Influxen som den kommer

%% Setting the start parameters 

v = w.tripping.vmax;
a = w.tripping.amax;
Vinflux = 0;
Voutflux = 0;
tvd = w.tally.dual.casingdepth + 20;

%% calculating other fixed parameters

csopenhole = pi/4*w.tally.dopenhole^2;                                      % cross section area of the open hole
cscasing = pi/4*w.tally.dual.idcasing^2;  %cross section area of the inside of the casing
csriser = pi/4*w.tally.idriser^2;     %cross section area of the inside of the riser
csandp = pi/4*(w.tally.dual.idcasing^2 - w.tally.ddrillpipe^2); % cross section area of Casing-Pipe-annulus
cscasbha = pi/4*(w.tally.dual.idcasing^2 - w.tally.odbha^2);% cross section area between casing and BHA
csriserannulus = pi/4*(w.tally.idriser^2-w.tally.ddrillpipe^2)             % cross section area between the riser and the drill pipe
csareadp = w.tally.ddrillpipe^2*pi/4;                                       % cross section area of the drill pipe
csbha = w.tally.odbha^2*pi/4;

tint = 1;

%% Finding the start values for acceleration, etc.. 

ta = ceil( v / a ); % acceleration time
la = (v/2)*ta;   % length reached by acceleration phase. Linear acceleration phase, average acc is v,top divided by 2
tcv = ceil((w.tally.lstand - 2*la)/v); % tripping time at constant velocity
ttot = tcv + 2*ta;
lc = v*(ttot-2*ta);

if (lc + 2*la) ~= w.tally.lstand
    disp('The specified values for velocity and acceleration are not valid. ');
    disp('Please change values in the Excelsheet.');
    return
end

t = 1;
vtab(t) = 0;
atab(t) = 0;
vtabell(t) = 0;

l = 0;
lengde = 0;

while l < la
    t = t + tint;
    atab(t) = a;
    vtab(t) = vtab(t-1) + a*tint ;
    l = l + vtab(t);
%         disp([' Lengden har kommet til: ',num2str(l),'  - Tiden er: ',num2str(t)]);
end

while l < (la + lc)

         t = t + tint;

    vtab(t) = v;
    atab(t) = 0;
    l = l + vtab(t);
    if l == (la + lc - 2*tint)
        atab(t) = -a;
    end
end

while l < (lc + 2*la) && t < ttot
    t = t + tint;
    atab(t) = -a;
    vtab(t) = vtab(t-1) + atab(t)*tint;

    l = l + vtab(t);
    if l == w.tally.lstand || t == ttot
        vtab(t+1) = 0;
        atab(t+1) = -a;
    end

end

p = 0;
if p == 1;
figure;
plot(atab);
title('Acceleration of the drillpipe during RIH','FontWeight','Bold');
xlabel('Time [s]','FontWeight','Bold');
ylabel('Acceleration [m/s2]','FontWeight','Bold');
axis([0,length(atab)+1,min(atab)*1.1,max(atab)*1.1]);
grid on;

figure;
plot(vtab);
title('Velocity of the drillpipe during RIH','FontWeight','Bold');
xlabel('Time [s]','FontWeight','Bold');
ylabel('Velocity [m/s]','FontWeight','Bold');
axis([0,length(vtab)+1,min(vtab),max(vtab)*1.2]);
grid on;

end

%% Setting other parameters and start values
dfi = pshoe.fi
d = pshoe.fi; %setting the depth of the BHA at starting time
dtarget = w.tally.dual.casingdepth;
tripreps = floor((dtarget-d)/w.tally.lstand ); %finding how many times the tripping procedure must be done to reach bottom

%Defining minimum hydrostatic pressure
Phydshoemin = x.pptab(w.tally.dual.casingdepth) + w.formation.phydmargin*1e5 %abolute minimum allowed Phyd pressure
dfimax = (Phydshoemin - w.fluid.rho2*w.misc.g*w.tally.dual.casingdepth)/(w.fluid.rho1-w.fluid.rho2)/w.misc.g  % corresponding dfi at Phydshoemin

t = 1;
qsp = w.pumps.qspmin;
qbp = w.pumps.qbpmin;
qsptab(t) = qsp;
qbptab(t) = qbp;

dfitab(t) = dfi
dfitarget = dfi;
dVformflux(t) = 0;

dPfitot = 0;
Pshoestart = pshoe.pshoe;
Phyd = Pshoestart;
Pshoe = Pshoestart;
Pshoetab(t) = Pshoe;    %setting the P at the casing shoe. indata "t".

l = 0;

k=1;

%% Starting the tripping process and counter for number of stands
for j = 1:tripreps
clear dPfftab;
k = 1;  %resetting the counter for the atab and vtab for every time the for-loop is run. 
% disp(['  ']);
% disp(['                                                      Her er DFI [m]: ',num2str(dfi)]);
dtemp = d;
%% Procedure for the tripping with one stand
while k <= ttot

     if k == 1 %if at the first run of a cycle. => MAIN point inside this if-loop is to find "dfitarget" to be used.
        i = 1;
        while i<=ttot %creating the test-table with the coming values for 
            i= i+1;
            if i <= ta % checking if the pipe is in an acceleration place.
                % OBS: lag funksjon som deler opp i akselerasjon og ikke... 
                testtab(i) = surgepress(w,vtab(i),atab(i),d,dfi); % finding the change in pressure, with acceleration
            elseif  ta < i && i <= (tcv + ta)
                testtab(i) = surgepress(w,vtab(i),0,d,dfi); % finding the change in pressure, without acceleration
            elseif (tcv + ta) < i
                testtab(i) = surgepress(w,vtab(i),atab(i),d,dfi);
            end
                d = d + 1;
        end

        minP = Pshoe + min(testtab); %surgepress(w,vtab(ttot-1),min(atab),(d+w.tally.lstand)); %the minimum pressure experienced at the Shoe during the movement
%          disp(['Her er minP ',num2str(minP/1e5),' bar']);
        % Utregningene av minP og maxP blir litt overdrevet, siden min/max ikke skjer i
        % slutten av en standlengde, som det regnes med her. Dette gir
        % likevel bare ekstra sikkerhetsmargin.
        maxP = Pshoe + max(testtab); % surgepress(w,max(vtab),min(vtab),(d+w.tally.lstand)); %the maximum pressure experienced at the Shoe
%          disp(['Her er maxP ',num2str(maxP/1e5),' bar']);
        
         % sjekker om trykket vil komme til  overg marginen
        if maxP > x.fpmargintab(w.tally.dual.casingdepth)
            deltaP = maxP - x.fpmargintab(w.tally.dual.casingdepth); % pkrevd trykkksenkning
            ddfi = deltaP/(w.fluid.rho2-w.fluid.rho1)/w.misc.g; % s mye som dette m fluid interfacelevel senkes
            dfitarget = dfi + ddfi; % nr trykket m senkes, m dybden p fluid interface kes.
%              disp(['nummer er ',num2str(j),' og  dfitarget er: ',num2str(dfitarget)]);
            
%             if dfitarget > w.tally.dual.depthmaxfi || dfitarget < 0
%                 1
%                 disp(['OBSOBS! Her er noe feil, dfitarget er strre enn maxdybde. dfiTarget er: ',num2str(dfitarget)]);
%                 dfitarget = w.tally.dual.depthmaxfi;
%                 return
%             end
            
        end
%         disp(['Her er differansen mellom minP og Ppore ',num2str((minP-x.pptab(w.tally.dual.casingdepth))/1e5),' bar']);
        
%         if minP < x.pptab(w.tally.dual.casingdepth) % sjekker om Pmud vil g under Poretrykket.
%             deltaP = minP - x.pptab(w.tally.dual.casingdepth); % pkrevd trykkendring. negativt tall her betyr at trykket m kes.
%             ddfi = deltaP/(w.fluid.rho2-w.fluid.rho1)/w.misc.g; % s mye m dfi endres. (negativt tall her betyr at dfi m minkes( flyttes oppover i riser)
%             dfitarget = dfi + ddfi;
%             disp(['NUMMERET ER ',num2str(j),' OG DFITARGET ER: ',num2str(dfitarget)]);
%             

            
        if dfitarget > dfimax % sjekker om dfitarget gr under minimumsgrensen. 
            dfitarget = dfimax;
        end
            
            
%         end
        d = dtemp; % picking up the old stored value for "d"
        clear dPfftab
        
     end



t = t + tint;
k = k + tint;

% The pressure change that comes because of fluid friction
    if k <= ta % checking if the pipe is in an acceleration place.
        % OBS: lag funksjon som deler opp i akselerasjon og ikke... 
        dPfftab(k) = surgepress(w,vtab(k),atab(k),d,dfi); % finding the change in pressure, with acceleration
    elseif  ta < k && k <= (tcv + ta)
        dPfftab(k) = surgepress(w,vtab(k),0,d,dfi); % finding the change in pressure, without acceleration
	elseif (tcv + ta) < k
        dPfftab(k) = surgepress(w,vtab(k),atab(k),d,dfi);
    end
%     disp(['Surge press her er: ',num2str(dPfftab(k)/1e5),' -  Dybden er: ',num2str(d)]);
    if j == 15 && k == ttot
        for i = 1:length(dPfftab)
        tabber(i) = dPfftab(i);
        end
    end


% The pressure change that comes because of increase in fluid interface due
% to added pipevolume
dVpipe = vtab(k) * csareadp * tint; % change in volume in the drillpipe   [m3]
% disp(['Her er DVPIEP [bar]: ',num2str(dVpipe)]);
dVformflux(t) = formationflow(w,x,Pshoe,w.tally.dual.casingdepth); % the calculated influx volume [m3]
% disp(['Her er DVFORMFLUX [m3]: ',num2str(dVformflux(t))]);

if dVformflux(t) > 0
    Vinflux = Vinflux + dVformflux(t);
elseif dVformflux(t) < 0
    Voutflux = Voutflux + dVformflux(t);
end

ddfi = ( -dVpipe - dVformflux(t) )/csriserannulus;   
dfi = dfi + ddfi;
p=0;
if p == 1
disp(['Her er PSHOE PSHOE PSHOE [bar]: ',num2str(Pshoe/1e5)]);
disp(['Her er RISERANNULUS ER H E R [L]: ',num2str(csriserannulus)]);
disp(['Her er DVFORMFLUX [m3]: ',num2str(dVformflux(t))]);
disp(['Her er     DVPIPEPIPE      [m3]: ',num2str(dVpipe)]);

disp(['Her er DFI [m]: ',num2str(dfi)]);
disp(['Her er DELTA DELTA DFI [m]: ',num2str(ddfi)]);
disp(['   ']);
end

if qsp<=0
    qbp = min(w.pumps.qbpmax,abs(qsp))
    qsp = w.pumps.qspmin;
end

if dfi > dfitarget
    %regn ut ndvendig volum, og deretter ndvendig rate.
    reqV = csriserannulus*(dfi-dfitarget);
    qbp = min((reqV*6e4+w.pumps.qspmin),w.pumps.qbpmax);
    qsp = w.pumps.qspmin;
elseif dfi < dfitarget
    reqV = csriserannulus*(dfitarget-dfi);
    qsp = min((reqV*6e4),w.pumps.qspmax);
    qbp = w.pumps.qbpmin;
end

ddfi = ( qbp/6e4 - qsp/6e4 )/csriserannulus;
dfi = dfi - ddfi;
dfitab(t) = dfi;


% new P at the shoe is then calculated
Phyd = (dfi*w.fluid.rho1*w.misc.g + (w.tally.dual.casingdepth-dfi)*w.fluid.rho2*w.misc.g);
Pshoe = dPfftab(k) + Phyd;


Pshoetab(t) = Pshoe;

qrptab(t) = 0; % legger inn verdiene i tabeller
qsptab(t) = qsp;
qbptab(t) = qbp;

    d = d + vtab(k) * tint; %the new depth of the BHA
    l = l + vtab(k) * tint;
	ttab(t) = t;
end

end

p==0;
if p==1
figure;
plot(tabber/1e5);
title('Pressure change in the wellbore during tripping operation','FontWeight','Bold');
xlabel('Time [s]','FontWeight','Bold');
ylabel('Pressure [bar]','FontWeight','Bold');
linje = [tabber(1),tabber(1)];
line([-1,length(tabber)],linje/1e5,'Color','r');
legend('Dynamic Pressure','Start pressure','Location','NorthEast');
grid on;
end

%% Calculate volumes for calculating the change in fluid density
netVformation = Vinflux + Voutflux;

% Volume from the BHA to the dfi when the BHA is at the Casing shoe:
% Calculating by findign: Volume empty hole - Volume drillstring

Vemptyhole = cscasing*(w.tally.dual.casingdepth-w.tally.conv.lriser) + csriser*(w.tally.conv.lriser-dfi)
Vdrillstring = w.tally.lbha*csbha + (d-w.tally.lbha-dfi)*csareadp
Vanaboveshoe = Vemptyhole - Vdrillstring

if netVformation > 0
    newrho = (Vanaboveshoe-Vinflux)/Vanaboveshoe*w.fluid.rho2 + Vinflux/Vanaboveshoe*w.fluid.formfluid;
else
    newrho = w.fluid.rho2;
end
dPshoe = (newrho-w.fluid.rho2)*(w.tally.dual.casingdepth-dfi)*w.misc.g;

ddfirho = dPshoe/(newrho-w.fluid.rho1)/w.misc.g; % Required change in depth at the casing shoe to counteract this change.
% Vantot = Vanaboveshoe + csopenhole*(tvd-w.tally.dual.casingdepth);

%% Setting the hydrostatic pressure in the riser back to the original level
p=1;
if p== 1
dfitarget = ( pshoe.fi + ddfirho);
while dfi ~= dfitarget
        t = t+1;
    diffeP = pshoe.pshoe-Pshoe;
    
    if dfi > dfitarget
        %regn ut ndvendig volum, og deretter ndvendig rate.
        reqV = csriserannulus*(dfi-dfitarget);
        qbp = min((reqV*6e4+w.pumps.qspmin),w.pumps.qbpmax);
        qsp = w.pumps.qspmin;
    elseif dfi < dfitarget
        reqV = csriserannulus*(dfitarget-dfi);
        qsp = min((reqV*6e4),w.pumps.qspmax);
        qbp = w.pumps.qbpmin;
    end

	ddfi = ( qbp/6e4 - qsp/6e4 )/csriserannulus;
    dfi = dfi - ddfi;
    
    Pshoe = (dfi*w.fluid.rho1*w.misc.g + (w.tally.dual.casingdepth-dfi)*newrho*w.misc.g);

    dfitab(t) = dfi;
    Pshoetab(t) = Pshoe;
    qbptab(t) = qbp;
    qsptab(t) = qsp;
    ttab(t) = t;
    dVformflux(t) = formationflow(w,x,Pshoe,w.tally.dual.casingdepth);
end
end

for i = max(ttab):(max(ttab)*1.05)
    ttab(i) = i;
    Pshoetab(i) = (dfi*w.fluid.rho1*w.misc.g + (w.tally.dual.casingdepth-dfi)*newrho*w.misc.g);
    qsptab(i) = w.pumps.qspmin;
    qbptab(i) = w.pumps.qbpmin;
    dfitab(i) = dfi;
    dVformflux(i) = formationflow(w,x,Pshoe,w.tally.dual.casingdepth);
end

figure;
bar(ttab/3600,dVformflux*1000);
title(' Influx and Outflux ','FontWeight','Bold','FontSize',14);
ylabel('Incremental fluid Flow [L]','FontWeight','Bold','FontSize',14);
xlabel('Time [hr]','FontWeight','Bold','FontSize',14);
influx = ['Total formation influx volume: ',num2str(Vinflux*1000),' L'];
outflux = ['Total mud volume lost to the formation: ',num2str(Voutflux*1000),' L'];

text1 = ['Influx volume in percent of original mud volume: ',num2str(100*netVformation/Vanaboveshoe),' %'];
text2 = ['Theoretical new density d.t. influx: ',num2str(newrho),'kg/m3'];
text3 = ['Theoretical change in Phyd at Shoe: ',num2str(dPshoe/1e5),' bar'];
text4 = ['Assumed formation fluid density: ',num2str(w.fluid.formfluid),' kg/m3'];
% text(0.03*length(ttab)/3600,0.75*max(dVformflux*1000),{influx;outflux;' ';text1;text2;text3});

%% plotting Pressure at shoe. 
figure;
plot(ttab/3600, Pshoetab/1e5,'-b');
axis([0, t/3600*1.1,x.pptab(w.tally.dual.casingdepth)*0.99/1e5,x.fptab(w.tally.dual.casingdepth)*1.01/1e5 ]);
title('Mud Pressure at the Casing Shoe; Pressure Margins included','FontWeight','Bold','FontSize',14);

fpmline = [x.fpmargintab(w.tally.dual.casingdepth),x.fpmargintab(w.tally.dual.casingdepth)];
ppmline = [x.ppmargintab(w.tally.dual.casingdepth),x.ppmargintab(w.tally.dual.casingdepth)];
fpline = [x.fptab(w.tally.dual.casingdepth),x.fptab(w.tally.dual.casingdepth)];
ppline = [x.pptab(w.tally.dual.casingdepth),x.pptab(w.tally.dual.casingdepth)];
pmudline = [ Pshoestart, Pshoestart];

line([-1,t],fpline/1e5,'Color','k');
line([-1,t],fpmline/1e5,'Color','k','Line','--');
line([-1,t],ppmline/1e5,'Color','r','Line','--');
line([-1,t],ppline/1e5,'Color','r');
line([-1,t],pmudline/1e5,'Color','y');

hleg2 = legend('P-mud','P-fracture','P-fracture,m','P-pore,m','P-pore','P-hyd@start');
set(hleg2,'Location','NorthWest');
xlabel('Time [hr]','FontWeight','Bold','FontSize',14);
ylabel('Pressure [bar]','FontWeight','Bold','FontSize',14);

tekst1 = ['Velocity of the pipe:     ',num2str(w.tripping.vmax),' m/s']; % creates a text string with different info
tekst2 = ['Acceleration of the pipe: ',num2str(w.tripping.amax),' m/s2'];
tekst3 = ['Start depth: ',num2str(round(pshoe.fi)),' mTVD'];
tekst4 = ['End depth: ',num2str(round(d)),' mTVD'];
hours = floor(ttab(length(ttab))/3600);
minutes = round((ttab(length(ttab))/3600 - hours)*60);
tekst5 = ['The total moving tripping time is: ',num2str(hours),' hrs + ',num2str(minutes),' mins'];
% text((0.01*max(ttab)/3600),(x.ppmargintab(w.tally.dual.casingdepth) + x.pptab(w.tally.dual.casingdepth))/2/1e5...
%     ,{tekst1;tekst2;tekst3;tekst4;' ';tekst5},'FontWeight','bold');

%% plotting the pump rates. 
figure;
plot(ttab/3600,qsptab, ttab/3600, qbptab );
legend('Subsea pump','Booster pump','Location','NorthWest');
title('Pump rates','FontWeight','Bold','FontSize',14);
xlabel('Time [hr]','FontWeight','Bold','FontSize',14);
ylabel(' Pump rates [LPM]','FontWeight','Bold','FontSize',14);
axis([0,length(ttab)/3600*1.1,0,max(max(qsptab),max(qbptab))*1.1]);

%% Plotting the depth of the fluid interface
figure;
plot(ttab/3600,dfitab);
title('Depth of Fluid Interface','FontWeight','Bold','FontSize',14);
xlabel('Time [hr]','FontWeight','Bold','FontSize',14);
ylabel(' Depth [mRKB]','FontWeight','Bold','FontSize',14);
set(gca,'YDir','reverse');
dPtekst = ['Hydrostatic pressure has varied with: ',num2str(w.misc.g*(w.fluid.rho2-w.fluid.rho1)*(max(dfitab)-min(dfitab))/1e5),' bar'];
% text(length(ttab)*0.03/3600,min(dfitab) + 2/3*(max(dfitab)-min(dfitab)),dPtekst);

%% Writing selected results to an Excelsheet
results = [round(pshoe.fi); round(d); round(tvd);0;...
    (max(dPfftab)-min(dPfftab))/1e5;Voutflux*1000; Vinflux*1000;newrho;dPshoe/1e5;0;...
    (dfitab(length(dfitab))-dfitab(1)); (Pshoetab(length(Pshoetab))-Pshoetab(1))/1e5; 0;...
    ttab(length(ttab))/3600; w.tripping.vmax; w.tripping.amax; w.tripping.acf; 0; ...
    w.fluid.rho1; w.fluid.rho2; w.fluid.formfluid; 0;...
    w.pumps.qspmax; w.pumps.qbpmax; w.pumps.qspmin; w.pumps.qbpmin; 0];
xlswrite('Results.xlsx',results);
end