% This function sets the Phyd at the casing shoe to a value that is functional within the mud
% window. It decides the fluid interface level that have to be set when
% using the defined mud densities

function out = setPshoe(w,t)

out.pshoe = 0;
out.fi = 0;

Pshoewish = t.ppmargintab(w.tally.dual.casingdepth) + w.formation.bhpm*w.misc.g*w.tally.dual.casingdepth; %defining the preferred BHP for drilling.
fiwish = (Pshoewish/w.misc.g - w.tally.totalvd*w.fluid.rho2)/(w.fluid.rho1-w.fluid.rho2); % finds what the fi have to be to get BHPwish

fi = fiwish;

while fi > w.tally.dual.depthmaxfi
    fi = fi - 1;
%  	disp(['Fi er her: ',num2str(fi)]);
end

ok = 0;
while ok == 0
    if fi < 1
        disp(['Mud Weight is probably too low . Fi is equal to ',num2str(fi)]);
        out.pshoe = 0;
        return
    end
    %BHP is here defined to be a defined margin (ideal for safety and rate of penetration) above the pore pressure.
    Pshoe = (fi*w.fluid.rho1*w.misc.g + (w.tally.dual.casingdepth-fi)*w.fluid.rho2*w.misc.g);

    if Pshoe < ( t.ppmargintab(w.tally.dual.casingdepth) + 15*1e5 )
        fi = fi - 1;
%          	disp(['nivet ble kt her: ',num2str(fi)]);
        continue
    elseif Pshoe > t.fpmargintab(w.tally.dual.casingdepth)
        fi = fi + 1;
%         disp(['nivet ble SENKET!  her: ',num2str(fi)]);
        continue

    else
        ok = 1;
    end

end

out.pshoe = Pshoe;
out.fi = fi;
end