function out = surgepress(w,v,a,d,dfi);

%% 
% Lign (1):     phi1 = A * phi2^B * phi3^C * (phi4 + D)^E * phi5^F;
% Lign (2):     phi1 = A * phi2^B * phi3^C * phi4^D * (E + phi5)^F;



% denne skal utfre:
% => finne trykkendringen som skjer i brnnen pga pipebevegelse. antar
% inkompressibel fluid, og dermed blir ogs trykkendringen lik ved BHA som
% ved bunnen av brnnen.
% => IKKE finne trykket ved spesielle dybder, det legges til en annen
% funksjon  finne. 

% Problemer som m finnes lsninger p:
%   => Akselerasjonsfasen. Gjr en god vurdering p hvor mye den skal endre
%      seg. Ta hensyn til Inertia, Gelstregth, som nevnt i en referanse.
%   => 

dbhatop = d - w.tally.lbha; %depth of the top of the bha
dPtot = 0;

if v == 0
    out = dPtot;
else



%% General parameters
n = w.fluid.ypl.n;
k = w.fluid.ypl.K;
ty = w.fluid.ypl.ty;
A = w.tripping.A;
B = w.tripping.B;
C = w.tripping.C;
D = w.tripping.D;
E = w.tripping.E;
F = w.tripping.F;
phi5 = n;

%% 1 Surge created by drillstring in the light fluid in the riser
% Neglected

%% 2 - Surge created by drillstring in the heavy fluid in lower part of the riser
p = 0;
if p == 0
if dbhatop >= dfi

    L = min(dbhatop - dfi  ,  w.tally.seafloor-dfi);
    H = (w.tally.idriser - w.tally.ddrillpipe)/2;
    W = pi/2*(w.tally.idriser + w.tally.ddrillpipe);
    phi2 = (w.fluid.rho2 * H^n * v^(2-n)) / k;
    phi3 = W/H;
    phi4 = ((H/v)^n) * ty / k;
    phi1 = A * phi2^B * phi3^C * phi4^D * (E + phi5)^F;

    dP = L * phi1 /(H/k) / (H/v)^n;
    dPtot = dPtot + dP;
end
end

%% 3 - Surge created by the drillstring in the casing
p = 0;
if p == 0
if dbhatop > w.tally.seafloor
    L = min(dbhatop - w.tally.seafloor, w.tally.dual.casingdepth - w.tally.seafloor) ;
%      disp(['Lengden er: ',num2str(L)]);
    H = (w.tally.dual.idcasing - w.tally.ddrillpipe)/2;
    W = pi*(w.tally.dual.idcasing + w.tally.ddrillpipe)/2;

    phi2 = (w.fluid.rho2 * H^n * v^(2-n)) / k;
    phi3 = W/H;
    phi4 = ((H/v)^n) * ty / k;
    phi1 = A * phi2^B * phi3^C * phi4^D * (E + phi5)^F;

    dP = L * phi1 /(H/k) / (H/v)^n;
    dPtot = dPtot + dP;
end
end

%% 4 - Surge created by the drillstring in the open hole
q = 0;
if q == 0
if dbhatop > w.tally.dual.casingdepth
	L = min(dbhatop - w.tally.dual.casingdepth   ,  w.tally.totalvd - w.tally.dual.casingdepth - w.tally.lbha);
	H = (w.tally.dopenhole - w.tally.ddrillpipe)/2;
    W = pi*(w.tally.dopenhole + w.tally.ddrillpipe)/2;
    
    phi2 = (w.fluid.rho2 * H^n * v^(2-n)) / k;
    phi3 = W/H;
    phi4 = ((H/v)^n) * ty / k;
    phi1 = A * phi2^B * phi3^C * phi4^D * (E + phi5)^F;

    dP = L * phi1 /(H/k) / (H/v)^n;
    dPtot = dPtot + dP;
end
end

%% 5 - Surge by the BHA
p = 0;
if p == 0
L = w.tally.lbha;
H = (w.tally.idriser - w.tally.odbha)/2;
W = pi*(w.tally.idriser + w.tally.odbha)/2;
if d > w.tally.dual.casingdepth
    H = (w.tally.dopenhole - w.tally.odbha)/2;
    W = pi*(w.tally.dopenhole + w.tally.odbha)/2;
%   	disp(['BHA 1 er: ',num2str(w.tally.odbha/w.tally.idriser)]);
elseif d > w.tally.seafloor

    H = (w.tally.dual.idcasing - w.tally.odbha)/2;
    W = pi*(w.tally.dual.idcasing + w.tally.odbha)/2;
%       disp(['Er det her det blir kdd ???? W/H er: ',num2str(W/H)]);    
%         	disp(['BHA 2 er: ',num2str(w.tally.odbha/w.tally.dual.idcasing)]);
elseif d > dfi
    H = (w.tally.idriser - w.tally.odbha)/2;
    W = pi*(w.tally.idriser + w.tally.odbha)/2;
%   	disp(['Her skjer det tAng???? W/H er: ',num2str(W/H)]);    
%       	disp(['BHA 3 er: ',num2str(w.tally.odbha/w.tally.idriser)]);
end

    phi2 = (w.fluid.rho2 * H^n * v^(2-n)) / k;
    phi3 = W/H;
    phi4 = ((H/v)^n) * ty / k;
    phi1 = A * phi2^B * phi3^C * phi4^D * (E + phi5)^F;

    dPbha = L * phi1 /(H/k) / (H/v)^n;
%       disp(['dP fra BHA er: ',num2str(dPbha/1e5)]);
%         	disp(['BHA 4 er: ',num2str(w.tally.odbha/w.tally.idriser)]);
%       disp(['dPtot er: ',num2str(dPtot/1e5)]);
     dPtot = dPtot + dPbha;

end


%% Adding the acceleration correction factor
if a == 0;
    out = dPtot;
elseif a > 0
    out = dPtot * (1 + a * w.tripping.acf);
elseif a < 0
    out = dPtot * a * w.tripping.acf;
end
%      disp(['out er: ',num2str(dPtot/1e5)]);

end
end